// This is the main project file for VC++ application project 
// generated using an Application Wizard.

#include "stdafx.h"

//#define USING_IJW
#define USING_INTEROP

#using <mscorlib.dll>

using namespace System;
using namespace System::Runtime::InteropServices;
using namespace System::Text;

#define		BOOL					int
#define		TRUE					1
#define		FALSE					0

#define	    COMPRESSION_NONE		1	/* dump mode */
#define	    COMPRESSION_CCITTRLE	2	/* CCITT modified Huffman RLE */
#define	    COMPRESSION_CCITTFAX3	3	/* CCITT Group 3 fax encoding */
#define	    COMPRESSION_CCITTFAX4	4	/* CCITT Group 4 fax encoding */
#define	    COMPRESSION_LZW		5       /* Lempel-Ziv  & Welch */
#define	    COMPRESSION_JPEG		7	/* %JPEG DCT compression */
#define	    COMPRESSION_PACKBITS	32773	/* Macintosh RLE */

[DllImport("pdf2image.dll", CharSet=CharSet::Auto)]
extern "C" unsigned int PDFToImageConverter(
	[MarshalAs(UnmanagedType::LPStr)] String *FileName,
	[MarshalAs(UnmanagedType::LPStr)] String *OutputName,
	IntPtr UserPassword, IntPtr OwnPassword,
	int xresolution, int yresolution, int bitcount, 
	int compression, int quality, int grayscale, 
	int multipage,  int firstPage, int lastPage);

int ConvertFile(String *NameIn, String *NameOut)
{
	int RetVal = -1;
	try
	{
		IntPtr UserPassword = IntPtr::Zero;
		IntPtr OwnPassword = IntPtr::Zero;
		int xRes = 200;
		int yRes = 200;
		int bitcount = 24;
		int compression = COMPRESSION_CCITTFAX4;
		int quality = 70;
		BOOL grayscale = FALSE;
		BOOL multipage = TRUE;
		int FirstPage = -1;
		int LastPage = -1;

		RetVal = PDFToImageConverter(NameIn, NameOut, UserPassword, OwnPassword,
			xRes, yRes, bitcount, compression, quality, grayscale, multipage, FirstPage, LastPage);
	}
	catch (Exception *ex)
	{
		Console::WriteLine(ex->Message);
	}
	return RetVal;
}

int _tmain()
{
	String *SourceFile = "C:\\DoesntWork.pdf";
	String *DestFile = "C:\\temp.tif";

	StringBuilder *sb = new StringBuilder(4096);
	sb->Append("Interop, converting ");
	sb->Append(SourceFile);
	sb->Append(" to ");
	sb->Append(DestFile);
	Console::WriteLine(sb->ToString());

	int RetVal = ConvertFile(SourceFile, DestFile);

	if (sb->Length > 0)
		sb->Remove(0, sb->Length);
	sb->Append("Returned: ");
	sb->Append(RetVal.ToString());
	sb->Append(", press enter...");
	Console::Write(sb->ToString());
	Console::ReadLine();
	return 0;
}
